/*
 * Player.java
 *
 * Created on 28 novembre 2007, 21.34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package babaoglu;

import java.util.*;

/**
 * Questa classe descrive il Player, cio� il giocatore.
 * <BR>
 * In realt� � semplice: un giocatore ha un nome, un inventario e una lista di 
 * Pietre Miliari che descrivono il suo progresso nel gioco.
 * @author dario
 */
public class Player {

    /**
     * Creates a new instance of Player
     * @param n Il nome del giocatore
     */
    public Player(String n, String d) {
        nome = n;
        locazione = d;
        inventario = new ArrayList<String>();
        progresso = new ArrayList<String>();
    }

    /**
     * Restituisce il nome del giocatore
     * @return Il nome del giocatore
     */
    public String getNome() {
        return nome;
    }

    public String getLocazione() {
//        System.out.println(this.locazione);
        return locazione;
    }

    public void setLocazione(String d) {
//        System.out.println("Player: locazione precedente = '"+ locazione + "'");
        locazione = d;
//        System.out.println("Player: locazione attuale = '" + locazione + "'");
        
    }
    
    /**
     * Ritorna la lista degli oggetti posseduti dal player
     * @return L'array degli oggetti del player
     */
    public String[] getInventario() {
        String[] a = new String[this.inventario.size()];
        a = inventario.toArray(a);
        
        return a;
    }

    /**
     * Aggiunge un oggetto all'inventario. Questa funzione controlla se l'oggetto
     * � mobile o no.
     * @param cosa La String col nome dell'Oggetto da aggiungere all'inventario.
     * @return <b>true</b> = ha aggiunto l'oggetto felicemente<BR>
     * <b>false</b> = non ha aggiunto l'oggetto
     */
    public Boolean aggiungiOggetto(String cosa) {
        Boolean risultato = false;

        if (cosa != null) {
            
            inventario.add(cosa);
            risultato = true;
        }

        return risultato;
    }

    /**
     * Rimuove un Oggetto, se esistente, dall'inventario del giocatore.
     * <BR>
     * Da notare che trova la prima occorrenza di un Oggetto con quel nome, e la toglie.
     * @param nome Il nome dell'Oggetto da togliere dall'inventario
     * @return Se l'oggetto � stato trovato, ritorna il nome dell'Oggetto Stesso.<BR>
     * Altrimenti ritorna <b>null</b>.
     */
    public String togliOggetto(String nome) {
        String risultato = null;
        Boolean trovato = false;
        int c = 0;

        while ((c < inventario.size()) && !trovato) {
            if (inventario.get(c).equals(nome)) {
                trovato = true;
            }
            if (!trovato) {
                c++;
            }
        }

        if (trovato) {
            risultato = inventario.get(c);
            inventario.remove(c);
        }

        return risultato;
    }

    /**
     * Aggiunge una Pietra Miliare al giocatore.
     * @param cosa Il nome della pietra miliare da aggiungere
     * @return <b>true</b> = Pietra Miliare aggiunta felicemente
     * <br>
     * <b>false</b> = Pietra Miliare non aggiunta
     */
    public Boolean aggiungiPietra(String cosa) {
        if (cosa != null) {
            return progresso.add(cosa);
        } else {
            return false;
        }
    }

    public Boolean togliPietra(String cosa) {
        return progresso.remove(nome);
    }
    
    public void svuotaInventario () {
        inventario.clear();
    }

    /**
     * Controlla se il giocatore ha o no l'oggetto indicato col nome.
     * @param nome Il nome dell'oggetto da controllare
     * @return <b>true</b> = l'ha trovato<br>
     * <b>false</b> = non l'ha trovato
     */
    public Boolean haOggetto(String nome) {
        Boolean risultato = false;
        int c = 0;

        while (c < inventario.size() && !risultato) {
            if (inventario.get(c).equals(nome)) {
                risultato = true;
            }
            c++;
        }

        return risultato;
    }

    public Boolean haPietra(String nome) {
        Boolean risultato = false;
        int c = 0;
        while (c < progresso.size() && !risultato) {
            if (progresso.get(c).equals(nome)) {
                risultato = true;
            }
            c++;
        }

        return risultato;

    }
    private String nome;
    private String locazione;
    private ArrayList<String> inventario;
    private ArrayList<String> progresso;
}
